function Aufgabe_7_1
close all;

% Anmerkung: es bietet sich an zuerst den Rand des Stabilitätsgebietes zu
% finden, d.h. |R(z)| = 1 zu plotten. Dann kann man über das relevante
% Gebiet ein Gitter legen um |R(z)| <= 1 zu plotten (kennt man den Rand
% nicht, weiß man nicht wo man das Gitter legen soll).

%% Diese Variante braucht die symbolic toolbox von MATLAB
% % Plot using implicit plot command ezplot
% % We plot |R(z)|^2-1=0, where z=x+iy
% % Notice that this only works provided you have bought a symbolic toolbox
% syms x y
% figure(1);
% ezplot(((x^2-y^2)/2+x+1)^2+(x*y+y)^2-1)
% axis([-2.5 0.5 -2 2])
% title('Stability region Runge')
% xlabel('Re(\lambda h)');
% ylabel('Im(\lambda h)');
% end


%% eine Variante den Rand zu finden
% 
% Wir bestimmen und plotten alle Nullstellen von R(z) - exp(it), für t
% zwischen 0 und 2pi, denn damit erhalten wir alle Punkte mit |R(z)| = 1. 
figure(2);
t=linspace(0,2*pi,100); % t aus [0, 2pi] 
for j=1:length(t)
    p=[1/2 1 1-exp(1i*t(j))]; % das Polynom, von dem wir die Nullstellen berechnen
    plot(roots(p),'x'); % plotten der Nullstellen
    hold on
end
axis([-2.5 0.5 -2 2])
title('Rand des Stabilitätsgebiet (Runge und Heun)')
xlabel('Re(\lambda h)');
ylabel('Im(\lambda h)');

%% eine andere Variante (contour ist okay, da das Gebiet beschränkt sein muss bei einem expliziten Verfahren
%
% Mittels des contour-Befehlt plotten wir die Niveaumenge von |R(z)| zum
% Niveau 1.
figure(3);
[X,Y]=meshgrid(-2.5:0.01:0.5,-2:0.01:2);
Z=X+1i*Y;
R=Z.^2/2+Z+1;
Rhat=abs(R);
contour(X,Y,Rhat,[1 1]);
title('Rand des Stabilitätsgebiet (Runge und Heun)')
xlabel('Re(\lambda h)');
ylabel('Im(\lambda h)');

%% Stabilitätsgebiet für Verfahren von Runge und Heun
%
% Gitter über relevanten Bereich
x1=-2.5:0.01:0.5;
y1=-2:0.01:2;
z1 = zeros(length(x1),length(y1));
f1=@(x,y) abs(1+(x+1i*y)+(x+1i*y)^2/2);
% finde nun f1 <= 1
for m=1:length(x1)
    for n=1:length(y1)
        if f1(x1(m),y1(n))<=1
            z1(n,m)=1;
        else
            z1(n,m)=NaN;
        end
    end
end

figure(4);
imagesc(x1,y1,z1); % imagesc statt image, da man sonst wegen NAN nichts sieht
title('Stabilitätsgebiet (Runge und Heun)');
xlabel('Re(\lambda h)');
ylabel('Im(\lambda h)');

%% Implizite Mittelpunktsformel: finde den Rand
%
t=linspace(0,2*pi,100);
figure(5);
for j=1:length(t)
    p=[1 2*(exp(1i*t(j))-1)/(exp(1i*t(j))+1)];
    plot(roots(p),'x');
    hold on
end
axis([-0.5 0.5 -0.5 0.5])
title('Rand des Stabilitätsgebiet (impl. MP)')
xlabel('Re(\lambda h)');
ylabel('Im(\lambda h)');

%% Nun die Stabilitätsregion
%
% Gitter über relevanten Bereich
x2=-0.5:0.01:0.5;
y2=-0.5:0.01:0.5;
z2 = zeros(length(x2),length(y2));
f2=@(x,y) abs((1+(x+1i*y)/2)/(1-(x+1i*y)/2));
% finde nun f2 <= 1
for m=1:length(x2)
    for n=1:length(y2)
        if f2(x2(m),y2(n))<=1
            z2(n,m)=1;
        else
            z2(n,m)=0;
        end
    end
end

figure(6);
imagesc(x2,y2,z2); % imagesc statt image, da man sonst wegen NAN nichts sieht
title('Stabilitätsgebiet (impl. MP)');
xlabel('Re(\lambda h)');
ylabel('Im(\lambda h)');
