function Aufgabe_7_4
close all
dbstop if error

%% (a)-Teil

N = 50; % schon für N=50 ist der kleinste negative Eigenwert sehr Negativ
kleinster_EW = zeros(N,1);
for k=1:N
    % Erstelle A
    e=ones(k,1);
    A=(k+1)^2*spdiags([e -2*e e],-1:1,k,k);
    kleinster_EW(k)= eigs(A,1,'sa'); % vgl. SIGMA in "help eigs"
end

figure;
plot(1:N,kleinster_EW)
grid on
xlabel('N')
ylabel('min eig(A)')
title('Kleinster negativer Eigenwert von A')

%% (c)-Teil 

% Werte aus der Aufgabe, das x-Intervall und den Anfagszeitpunkt definieren
% wir als globale Variable, so können wir diese in Unterfunktionen
% wiederfinden.
T=2; global t0; global x0; global xend; hx=0.05; Plotzeitpunkt=0.03; 
t0 = 0; x0 = 0; xend = 1;

% Diskretisierung in x-Richtung
x=x0:hx:xend;
% Anfangswerttemperaturverteilung
g=@(x) 0.0+1.0*(x>=1/4 & x<=3/4);
% Matrix A erstellen
M=length(x)-2; % -2, da die Randpunkte nicht enthalten sind, vgl. Aufgabenstellung
e=ones(M,1);
A=spdiags([e -2*e e],-1:1,M,M);
A=A/(hx^2);
% verschiedene Schrittweiten
h=[0.001 0.0015 0.003 0.03];

for l=1:length(h)
    % jeweils eine neue figure
    figure(l+1);
    hold on
    % Lösung via Implizites Euler und Mittelpunktsregel wird immer bestimmt
    [~,~,u_imp] = ImpEuler(T,h(l),hx,g,A); % Hinweis: mit ~ kann man output unterdrücken (z.B. wenn man ihn nicht braucht)
    [~,~,u_midpoint] = Midpoint(T,h(l),hx,g,A);
    % dies gibt den Eintrag zum Zeitpunkt t = 0.03 im Lösungsvektor an
    factor = Plotzeitpunkt/h(l) +1;     
    % nur für die ersten 2 Schrittweiten wird auch mit dem expliziten Euler gelöst
    if  l<=2
        [~,~,u_exp] = ExpEuler(T,h(l),hx,g,A);
        plot(x,u_exp(:,factor));
    end
    plot(x,u_imp(:,factor));
    plot(x,u_midpoint(:,factor));
    
    switch l % jeweils eine entsprechende Beschriftung
        case 1
            legend('Explziter Euler','Impliziter Euler','Mittelpunktsregel')
            title('h=0.001');
        case 2
            legend('Expliziter Euler','Impliziter Euler','Mittelpunktsregel')
            title('h=0.0015');
        case 3
            legend('Impliziter Euler','Mittelpunktsregel')
            title('h=0.003')
        otherwise
            legend('Impliziter Euler','Mittelpunktsregel')
            title('h=0.03')
    end
end

%% (b)-Teil

function [t,x,u] = ExpEuler(T,h,hx,g,A)

% Damit sind die Werte von t0,x0,xend der Funktion bekannt
global t0
global x0
global xend

% Zeitgitter
t=t0:h:T;
l=length(t);
% x-Gitter
x=x0:hx:xend;
M=length(x);
% Lösungsmatrix
u=zeros(M,l);
% Anfangswerte
u(:,1) = g(x);

for i=1:l-1 % Expliziter Euler
    u(2:end-1,i+1)=(speye(size(A))+h*A)*u(2:end-1,i);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [t,x,u] = ImpEuler(T,h,hx,g,A)

% Damit sind die Werte von t0,x0,xend der Funktion bekannt
global t0
global x0
global xend

% Zeitgitter
t=t0:h:T;
l=length(t);
% x-Gitter
x=x0:hx:xend;
M=length(x);
% Lösungsmatrix
u=zeros(M,l);
% Anfangswerte
u(:,1) = g(x);

for i=1:l-1 % Impliziter Euler
    u(2:end-1,i+1)=(speye(size(A))-h*A)\u(2:end-1,i);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [t,x,u] = Midpoint(T,h,hx,g,A)

% Damit sind die Werte von t0,x0,xend der Funktion bekannt
global t0
global x0
global xend

% Zeitgitter
t=t0:h:T;
l=length(t);
% x-Gitter
x=x0:hx:xend;
M=length(x);
% Lösungsmatrix
u=zeros(M,l);
% Anfangswerte
u(:,1) = g(x);
% Notation
Ah=h*A;
Id = speye(size(A));

for i=1:l-1 % implizite Mittelpunktsregel
    u_zwischen = (Id-Ah/2)\u(2:end-1,i);  % erst u_i+1/2 ermitteln
    u(2:end-1,i+1)=u(2:end-1,i) + Ah*u_zwischen; % dann u_i+1
end
